(function($) {
    $.fn.fxFitImage = function(params) {
		params = $.extend( {parent: false}, params);			
		this.each( function() {				
            var $img = $(this);						
            var $parent = ( !params.parent ? $img.parent() : $img.parents( params.parent ) );
            if( $parent.length > 0 ) {
                $img.removeAttr('height').removeAttr('width');
				_scaleImage( $img, $parent );
            }
        });
		
		function _scaleImage( $img, $parent) {	
			var reqWidth  = $parent.width();
			var reqHeight = $parent.height();
			var imgHeight = $img.height();
            var imgWidth  = $img.width();
									
			var perWidth  = (reqWidth/imgWidth)*100;
			var perHeight = (reqHeight/imgHeight)*100;
			
			if(perWidth > perHeight) {
				var propHeight  = (perWidth*imgHeight)/100;
				var propWidth = reqWidth;
			} else {
				var propWidth  = (perHeight*imgWidth)/100;
				var propHeight = reqHeight;			
			}
					
			var posX = (reqWidth-propWidth)/2;
			var posY = (reqHeight-propHeight)/2;			
			$img.attr( 'width', propWidth );
			$img.attr( 'height', propHeight );
			$img.css("margin-left",posX+"px");
			$img.css("margin-top",posY+"px");			
		}
	};
})(jQuery);

//$('img.main-bg').fxFitImage({parent : 'div#wrap-bg'});